KDE 4.2 PyKDE API Reference

- KDE's Python API

# KCompletionBase Class Reference

`from PyKDE4.kdeui import *`

## Detailed Description

Abstract class:
  This class can be used as a base class for new classes, but can not be instantiated directly.

## Enumerations

KeyBindingType | { TextCompletion, PrevCompletionMatch, NextCompletionMatch, SubstringCompletion }

## Methods

| __init__ (self)
| __init__ (self, KCompletionBase a0)
KCompletion | compObj (self)
KGlobalSettings.Completion | completionMode (self)
KCompletion | completionObject (self, bool hsig=1)
KCompletionBase | delegate (self)
bool | emitSignals (self)
KShortcut | getKeyBinding (self, KCompletionBase.KeyBindingType item)
KCompletionBase.KeyBindingMap | getKeyBindings (self)
bool | handleSignals (self)
bool | isCompletionObjectAutoDeleted (self)
| setAutoDeleteCompletionObject (self, bool autoDelete)
| setCompletedItems (self, QStringList items, bool autoSuggest=1)
| setCompletedText (self, QString text)
| setCompletionMode (self, KGlobalSettings.Completion mode)
| setCompletionObject (self, KCompletion compObj, bool hsig=1)
| setDelegate (self, KCompletionBase delegate)
| setEnableSignals (self, bool enable)
| setHandleSignals (self, bool handle)
bool | setKeyBinding (self, KCompletionBase.KeyBindingType item, KShortcut key)
| useGlobalKeyBindings (self)
| virtual_hook (self, int id, void data)

## Method Documentation

__init__ | ( |  | self ) |

Default constructor.

__init__ | ( | self, |
|  | KCompletionBase | a0
| ) |  |  |

KCompletion compObj | ( |  | self ) |

Returns a pointer to the completion object.

This method is only different from completionObject() in that it does not create a new KCompletion object even if the internal pointer is NULL. Use this method to get the pointer to a completion object when inheriting so that you won't inadvertently create it!!

Returns:
  the completion object or NULL if one does not exist.

KGlobalSettings.Completion completionMode | ( |  | self ) |

Returns the current completion mode.

The return values are of type KGlobalSettings.Completion. See setCompletionMode() for details.

Returns:
  the completion mode.

KCompletion completionObject | ( | self, |
|  | bool | hsig=1
| ) |  |  |

Returns a pointer to the current completion object.

If the completion object does not exist, it is automatically created and by default handles all the completion signals internally unless hsig is set to false. It is also automatically destroyed when the destructor is called. You can change this default behavior using the setAutoDeleteCompletionObject and setHandleSignals member functions.

See also compObj.

Parameters:

  | hsig | if true, handles completion signals internally.

Returns:
  a pointer the completion object.

KCompletionBase delegate | ( |  | self ) |

Returns the delegation object.

Returns:
  the delegation object, or 0 if there is none

See also:
  setDelegate()

bool emitSignals | ( |  | self ) |

Returns true if the object emits the signals.

Returns:
  true if signals are emitted

KShortcut getKeyBinding | ( | self, |
|  | KCompletionBase.KeyBindingType | item
| ) |  |  |

Returns the key-binding used for the specified item.

This methods returns the key-binding used to activate the feature feature given by item. If the binding contains modifier key(s), the SUM of the modifier key and the actual key code are returned.

Parameters:

  | item | the item to check

Returns:
  the key-binding used for the feature given by item.

See also:
  setKeyBinding

KCompletionBase.KeyBindingMap getKeyBindings | ( |  | self ) |

Returns a key-binding map.

This method is the same as getKeyBinding() except it returns the whole keymap containing the key-bindings.

Returns:
  the key-binding used for the feature given by item.

bool handleSignals | ( |  | self ) |

Returns true if the object handles the signals.

Returns:
  true if this signals are handled internally.

bool isCompletionObjectAutoDeleted | ( |  | self ) |

Returns true if the completion object is deleted upon this widget's destruction.

See setCompletionObject() and enableCompletion() for details.

Returns:
  true if the completion object will be deleted automatically

setAutoDeleteCompletionObject | ( | self, |
|  | bool | autoDelete
| ) |  |  |

Sets the completion object when this widget's destructor is called.

If the argument is set to true, the completion object is deleted when this widget's destructor is called.

Parameters:

  | autoDelete | if true, delete completion object on destruction.

setCompletedItems | ( | self, |
|  | QStringList | items,
|  | bool | autoSuggest=1
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

A pure virtual function that must be implemented by all inheriting classes.

Parameters:

  | items | the list of completed items
  | autoSuggest | if true, the first element of items is auto-completed (i.e. pre-selected).

setCompletedText | ( | self, |
|  | QString | text
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

A pure virtual function that must be implemented by all inheriting classes.

This function is intended to allow external completion implementations to set completed text appropriately. It is mostly relevant when the completion mode is set to CompletionAuto and CompletionManual modes. See KCompletionBase.setCompletedText. Does nothing in CompletionPopup mode, as all available matches will be shown in the popup.

Parameters:

  | text | the completed text to be set in the widget.

setCompletionMode | ( | self, |
|  | KGlobalSettings.Completion | mode
| ) |  |  |

Sets the type of completion to be used.

The completion modes supported are those defined in KGlobalSettings(). See below.

Parameters:

  | mode | Completion type:

- CompletionNone: Disables completion feature.
- CompletionAuto: Attempts to find a match &
fills-in the remaining text.
- CompletionMan: Acts the same as the above
except the action has to be manually triggered through pre-defined completion key.
- CompletionShell: Mimics the completion feature
found in typical *nix shell environments.
- CompletionPopup: Shows all available completions at once,
in a listbox popping up.

setCompletionObject | ( | self, |
|  | KCompletion | compObj,
|  | bool | hsig=1
| ) |  |  |

Sets up the completion object to be used.

This method assigns the completion object and sets it up to automatically handle the completion and rotation signals internally. You should use this function if you want to share one completion object among your widgets or need to use a customized completion object.

The object assigned through this method is not deleted when this object's destructor is invoked unless you explicitly call setAutoDeleteCompletionObject after calling this method. Be sure to set the bool argument to false, if you want to handle the completion signals yourself.

Parameters:

  | compObj | a KCompletion() or a derived child object.
  | hsig | if true, handles completion signals internally.

setDelegate | ( | self, |
|  | KCompletionBase | delegate
| ) |  |  |

Sets or removes the delegation object. If a delegation object is set, all function calls will be forwarded to the delegation object.

Parameters:

  | delegate | the delegation object, or 0 to remove it

setEnableSignals | ( | self, |
|  | bool | enable
| ) |  |  |

Sets the widget's ability to emit text completion and rotation signals.

Invoking this function with enable set to false will cause the completion & rotation signals not to be emitted. However, unlike setting the completion object to NULL using setCompletionObject, disabling the emition of the signals through this method does not affect the current completion object.

There is no need to invoke this function by default. When a completion object is created through completionObject or setCompletionObject, these signals are set to emit automatically. Also note that disabling this signals will not necessarily interfere with the objects ability to handle these events internally. See setHandleSignals.

Parameters:

  | enable | if false, disables the emition of completion & rotation signals.

setHandleSignals | ( | self, |
|  | bool | handle
| ) |  |  |

Enables this object to handle completion and rotation events internally.

This function simply assigns a boolean value that indicates whether it should handle rotation and completion events or not. Note that this does not stop the object from emitting signals when these events occur.

Parameters:

  | handle | if true, handle completion & rotation internally.

bool setKeyBinding | ( | self, |
|  | KCompletionBase.KeyBindingType | item,
|  | KShortcut | key
| ) |  |  |

Sets the key-binding to be used for manual text completion, text rotation in a history list as well as a completion list.

When the keys set by this function are pressed, a signal defined by the inheriting widget will be activated. If the default value or 0 is specified by the second parameter, then the key-binding as defined in the global setting should be used. This method returns false value for key is negative or the supplied key-binding conflicts with the ones set for one of the other features.

NOTE: To use a modifier key (Shift, Ctrl, Alt) as part of the key-binding simply simply sum up the values of the modifier and the actual key. For example, to use CTRL+E as a key binding for one of the items, you would simply supply "Qt.CtrlButton + Qt.Key_E" as the second argument to this function.

Parameters:

  | item | the feature whose key-binding needs to be set:

- TextCompletion the manual completion key-binding.
- PrevCompletionMatch the previous match key for multiple completion.
- NextCompletionMatch the next match key for for multiple completion.
- SubstringCompletion the key for substring completion

Parameters:

  | key | key-binding used to rotate down in a list.

Returns:
  true if key-binding can successfully be set.

See also:
  getKeyBinding

useGlobalKeyBindings | ( |  | self ) |

Sets this object to use global values for key-bindings.

This method changes the values of the key bindings for rotation and completion features to the default values provided in KGlobalSettings.

NOTE: By default inheriting widgets should uses the global key-bindings so that there will be no need to call this method.

virtual_hook | ( | self, |
|  | int | id,
|  | void | data
| ) |  |  |

Virtual hook, used to add new "virtual" functions while maintaining binary compatibility. Unused in this class.

## Enumeration Documentation

KeyBindingType

Text completion (by default Ctrl-E).

Enumerator:

  TextCompletion |
  PrevCompletionMatch |
  NextCompletionMatch |
  SubstringCompletion |